-- http://allaboutfpga.com/vhdl-testbench-tutorial/
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity upDownCounter is port(
  clock   : in std_logic;
  reset   : in std_logic;
  upDown  : in std_logic;
  counter : out std_logic_vector(3 downto 0));
end upDownCounter;
 
architecture bhv of upDownCounter is
  signal intrnlCntr: std_logic_vector(3 downto 0);
begin
  process (clock, reset) begin
    if (reset='1') then
    intrnlCntr <= "0000";
    elsif rising_edge(clock) then
      if upDown = '0' then
      intrnlCntr <= intrnlCntr + 1;
      else
      intrnlCntr <= intrnlCntr - 1;
      end if;
    end if;
  end process;
  counter <= intrnlCntr;
end bhv;
